<script setup>
import { computed } from 'vue';
import { attributesNameId } from '@/Compose/bootstrap';

const props = defineProps({
    modelValue: null,
    id: String,
    name: String,
    scale: {
        type: String,
        default: null
    },
    empty: Object,
    source: {
        type: [Array, Object],
        default: []
    },
    sourceKey: {
        type: String,
        default: null
    },
    sourceValue: {
        type: String,
        default: null
    },
    invalid: Boolean
})
const emit = defineEmits(['update:modelValue']);

const value = computed({
    get() {
        return props.modelValue;
    },
    set(value) {
        emit('update:modelValue', value);
    }
})
const { name, id } = attributesNameId(props.name, props.id);
</script>

<template>
    <select v-model="value" :id="id" :name="name" :class="['form-select', scale ? 'form-select-' + scale : '', {'is-invalid': Boolean(invalid)}]">
        <option v-if="empty" :value="empty.value" :disabled="Boolean(empty?.disabled)">{{ empty.label }}</option>
        <slot/>
        <template v-if="Array.isArray(props.source)">
            <template v-for="(item, index) in source">
                <option
                    v-if="typeof item === 'object'"
                    :value="props.sourceKey ? item[props.sourceKey] : Object.keys(item)[0]"
                    v-html="props.sourceValue ? item[props.sourceValue] : Object.values(item)[0]"
                    :key="Math.random()"
                />
                <option
                    v-else
                    :value="item"
                    v-html="item"
                    :key="Math.random()"
                />
            </template>
        </template>
        <template v-else>
            <option v-for="(value, key) in source" :value="key" v-html="value" :key="Math.random()"/>
        </template>
    </select>
</template>
